package MicroLang;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author       Adrian Knoth
 * @version 1.1
 */

public class BlockTy extends StatTy {

  MicroToken Id1;
  MicroToken Id2;
  DefTy DefPart;
  StatTy StatPart;
  BlockTy StaticPredecessor;

  public BlockTy() {
  }

  public BlockTy(MicroToken Id1, MicroToken Id2, DefTy DefPart,
                 StatTy StatPart, StatTy NextStat) {

    this.Id1 = Id1;
    this.Id2 = Id2;
    this.DefPart = DefPart;
    this.StatPart = StatPart;
    this.NextStat = NextStat;
  }

  public void identify(BlockTy SurrBlock) throws MicroSemanticError
  {
    this.StaticPredecessor = SurrBlock;
    if (DefPart!=null) DefPart.identify(this);
    if (StatPart!=null) StatPart.identify(this);
    if (NextStat!=null) NextStat.identify(SurrBlock);
  }

  public String typCompat () throws MicroSemanticError {
  }
}