package MicroLang;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author       Adrian Knoth
 * @version 1.0
 */

public class DefTy {

  MicroToken Id;
  MicroToken Type;
  ExprTy Init;
  DefTy NextDef;
  DefKindTy defKind = new DefKindTy (DefKindTy.VarD);

  boolean Valid =false;
  String RHSType;

  public DefTy() {
  }

  public DefTy(MicroToken Id, MicroToken Type, ExprTy Init, 
               DefKindTy DefKind, DefTy NextDef) {
    this.Id = Id;
    this.Type = Type;
    this.Init = Init;
    this.NextDef = NextDef;
    this.defKind = DefKind;
  }

  public void identify(BlockTy SurrBlock) throws MicroSemanticError
  {
    if (Init!=null) Init.identify(SurrBlock);
    this.Valid =true;
    if (NextDef!=null) NextDef.identify(SurrBlock);
  }

  public String typCompat () throws MicroSemanticError {
     if (null != Init) {
        RHSType = Init.typCompat ();
        if (! Type.getTokenValue().equalsIgnoreCase (RHSType)) {
           throw new MicroSemanticError ("types not compatible");
        }
     }
     if (null != NextDef) {
        NextDef.typCompat ();
     }

     return RHSType;
  }
}