package MicroLang;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author       Adrian Knoth
 * @version 1.0
 */

public class IfTy extends StatTy{

  ExprTy Condition;
  StatTy ThenPart;
  StatTy ElsePart;

  public IfTy() {
  }
  public IfTy(ExprTy Condition, StatTy ThenPart,
              StatTy ElsePart, StatTy NextStat) {
    this.Condition = Condition;
    this.ThenPart = ThenPart;
    this.ElsePart = ElsePart;
    this.NextStat = NextStat;

  }

  public void identify(BlockTy SurrBlock) throws MicroSemanticError
  {
    if (Condition!=null) Condition.identify(SurrBlock);
    else throw new MicroSemanticError("Condition in If-Statement is missing");

    if (ThenPart!=null) ThenPart.identify(SurrBlock);
    else throw new MicroSemanticError("Then Part in If-Statement is missing");

    if (ElsePart!=null) ElsePart.identify(SurrBlock);

    if (NextStat!=null) NextStat.identify(SurrBlock);

  }

  public String typCompat () throws MicroSemanticError {
  }
}