package MicroLang;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author      Adrian Knoth
 * @version 1.0
 */

public class WriteTy extends StatTy{

  ExprTy Expr;

  public WriteTy() {
  }

  public WriteTy(ExprTy Expr, StatTy NextStat) {

    this.Expr = Expr;
    this.NextStat = NextStat;

  }

  public void identify(BlockTy SurrBlock) throws MicroSemanticError
  {
    if (Expr!=null) Expr.identify(SurrBlock);
    else throw new MicroSemanticError("No Expression for Write-Statement");

    if (NextStat!=null) NextStat.identify(SurrBlock);
  }

  public String typCompat () throws MicroSemanticError {
  }
}