package MicroLang;

import java.io.LineNumberReader;
import java.io.IOException;
import java.io.FileReader;

public class MicroCompiler {

  public static void main(String args[])
  throws MicroLexicalError, MicroSyntaxError, MicroSemanticError {
    final LineNumberReader lnReader;

    System.out.println("Starting compilation ...");

    try {
      lnReader = new LineNumberReader(new FileReader(args[0]));
      MicroParser parsed = new MicroParser(lnReader);
      lnReader.close();
      System.out.println("finished compilation ...");
    }
    catch(IOException ioe) {
      System.out.println("Error while reading input file " + args[0]);
    }
  }
} 